rem Logs Data from ADM1034 temp sensor using I2C-2-PC adaptor
rem see www.i2cchip.com
rem This batch file is to run using CMD.EXE under XP (Not COMMAND.COM which lacks START)

rem customise for your system below...

set PORT=1

rem Log Commands must be set up for the number of ADM boards
set LOGCMDS=Read3TempsADMx1.i2c
rem set LOGCMDS=Read3TempsADMx4.i2c

rem Period is in ms between readings
set PERIOD=5000

set RT="c:\Program Files\BEL\realterm\realterm"
set CAPFILE=LogData.dat

rem Visible=0 makes Realterm disappear into the system tray while logging.
set VISIBLE=1

rem Initialise the ADM's. This file will init from1 to 4 ADM's. SENDQUIT sends the file, then quits
start "Initialising ADM1034" /wait %RT% flow=2 port=%PORT% SENDQUIT=InitADM.i2c caption=Initialising_ADM1034s

rem Now use Realterm to log. 
rem Because SENDREP=0, realterm will be running endlessly collecting data until it is stopped
start "" %RT% flow=2 port=%PORT% SENDDLY=%PERIOD% SENDREP=0 SENDFILE=%LOGCMDS% TIMESTAMP=3 caption="ADM1034_Logging" capture=%CAPFILE% visible=%VISIBLE%